//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
import React from 'react';

const Dashboard = React.lazy(() => import('./views/Dashboard'));
const Pipeline = React.lazy(() => import('./views/Pipeline'));
const Login = React.lazy(() => import('./views/Login'));
const Reporting = React.lazy(() => import('./views/Reports/ReportList'));
const DataSetDetails = React.lazy(() => import('./views/DataSetDetails'));
const OneSpatialDetails = React.lazy(() => import('./views/DataSetDetails/OneSpatialDetails/OneSpatialDetails'));
const OneSpatialDimensionDetails = React.lazy(() => import('./views/DataSetDetails/OneSpatialDetails/OneSpatialDimensionDetails'));
const DimensionDetails = React.lazy(() => import('./views/DataSetDetails/DimensionDetails'));

// https://github.com/ReactTraining/react-router/tree/master/packages/react-router-config
const routes = [
  { path: '/', exact: true, name: 'Home' },
  { path: '/login', exact: true, name: 'Login', component: Login },
  { path: '/pipeline', exact: true, name: 'Pipeline', component: Pipeline },
  { path: '/linkeddata', exact: true, name: 'Linked Data', component: Dashboard },
  { path: '/reporting', exact: true, name: 'Reporting', component: Reporting },
  { path: '/onespatial/:datasetID', exact: true, name: '1Spatial', component: OneSpatialDetails },
  { path: '/linkeddata/:datasetID', exact : true, name: 'Assessment Details', component: DataSetDetails },
  { path: '/linkeddata/:datasetID/:dimension', exact : true, name: 'Dimension Details', component: DimensionDetails },
  { path: '/onespatial/:datasetID/:dimension', exact : true, name: '1Spatial Dimension Details', component: OneSpatialDimensionDetails }
];

export default routes;
