//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.

import axios from 'axios';
import properties from '../../config/dashboardProperties';
import queryString from 'query-string';

const host = properties.luzzuFramework.host;
const port = properties.luzzuFramework.port;
/*-------------config-------------*/
const config ={
    //baseURL: 'http://'+host+':'+port+'/Luzzu/v4/',
    baseURL: 'http://'+host+'/Luzzu/v4/',
    timeout: 5000,
    headers: {'Accept': 'application/json','Content-Type':'application/x-www-form-urlencoded'}
  };

  axios.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
/*-----------------------------------*/

export const cancelAssessment = (lastAssessmentRequestID) => {

  let request = {
      "Request-ID":lastAssessmentRequestID
  }

  return axios.post('assessment/cancel',queryString.stringify(request), config)
    .then((response) => {
        return response;})
    .catch((err) => {
      if (!err.response) {
                  // network error
                console.log('Error: Network Error. Unable to connect to '+ host+":"+port);
      } else {
                console.log(err.response.data.message);
      }
        return err;
    });
}

export default {cancelAssessment};
