//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.

import axios from 'axios';
import properties from '../../config/dashboardProperties';
import queryString from 'query-string';
const host = properties.luzzuFramework.host;
const port = properties.luzzuFramework.port;
/*-------------config-------------*/
const config ={
    //baseURL: 'http://'+host+':'+port+'/Luzzu/v4/',
    baseURL: 'http://'+host+'/Luzzu/v4/',
    timeout: 5000,
    headers: {'Accept': 'application/json','Content-Type':'application/x-www-form-urlencoded'}
  };

axios.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
/*-----------------------------------*/

export const triggerAssessment = (props) => {
  let datasetLocation="";
  if(props.isSparqlEndPoint===true)
  {
    datasetLocation=props.sparqlEndPoint;
  }
  else {
    datasetLocation=props.fileName;
  }
  let metrics =[];

  metrics = props.assessmentMetrics.filter((metric) => {if(metric.assess & metric.javaPackageName!==""){return true;} return false;}).map((metric)=> {return (metric.javaPackageName);});
  let MetricConfiguration = {
    "@context": {
      "lmi": "http://purl.org/eis/vocab/lmi#",
      "rdf": "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
      "rdfs": "http://www.w3.org/2000/01/rdf-schema#",
      "xsd": "http://www.w3.org/2001/XMLSchema#" },
      "@id": "_:ub104bL6C1",
      "@type": "lmi:MetricConfiguration",
      "lmi:metric": [...metrics]}

  let request = {
      "Dataset-Location" : datasetLocation,
      "Quality-Report-Required" : true,
      "Dataset-PLD" : props.datasetPLD,
      "Is-Sparql-Endpoint" : props.isSparqlEndPoint,
      "Metrics-Configuration" :JSON.stringify(MetricConfiguration)

  }
return axios.post('assessment/compute',queryString.stringify(request), config)
  .then((response) => {
      return response;})
  .catch((err) => {
    if (!err.response) {
                // network error
              console.log('Error: Network Error. Unable to connect to '+ host+":"+port);
    } else {
              console.log(err.response.data.message);
    }
      return err;
  });

};

export default {triggerAssessment};
