//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
import axios from 'axios';
import queryString from 'query-string';
import properties from '../../config/dashboardProperties';


const host = properties.tripleStore.host;
const port = properties.tripleStore.port;
const dataStore = properties.tripleStore.datastore;
/*-------------config-------------*/
const config ={
    timeout: 10000,
    headers: {'Accept': 'application/sparql-results+json', 'Content-Type':'application/x-www-form-urlencoded'},
    withCredentials: true,
    auth: {username: properties.tripleStore.userName, password: properties.tripleStore.password}
  };
/*-----------------------------------*/

let url = "http://"+host+"/"+dataStore+"/update";



export const deleteGraph = (graphName) => {
              let query = "DROP GRAPH <http://"+host+":"+port+"/"+dataStore+"/data/"+graphName+">";
              //console.log(query);
                return  axios.post(url, queryString.stringify({update: query}), config)
                    .then((response) => {
                        return response.data;})
                    .catch((err) => {
                      if (!err.response) {
                                  // network error
                                console.log('Error: Network Error. Unable to connect to '+ host+":"+port);
                      } else {
                                console.log(err.response.data.message);
                      }
                        return err;
                    });
                }

export default {deleteGraph};
