//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
//Query to get all datasets
'use strict'

class AssessDataSetLists{
    constructor(){
        this.prefix = `
            PREFIX daq: <http://purl.org/eis/vocab/daq#>
            PREFIX sdma: <http://purl.org/linked-data/sdmx/2009/dimension#>
        `;
    }


    getAssessedDataSetDetails(){
        this.query = `
            SELECT DISTINCT ?QualityGraph ?computedOn ?timePeriod WHERE {
                ?QualityGraph ?predicate daq:QualityGraph.
                    {GRAPH ?subject {?Observation daq:computedOn ?computedOn} }
                 UNION
                    {GRAPH ?subject {?Observation sdma:timePeriod ?timePeriod} }
            }
        `;

        return this.prefix + this.query;
    }
}

export default AssessDataSetLists
