//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
const  prefix = `
PREFIX daq: <http://purl.org/eis/vocab/daq#>
PREFIX sdma: <http://purl.org/linked-data/sdmx/2009/dimension#>
PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>        
PREFIX da: <https://www.wowman.org/index.php?id=1&type=get#>
        `;



export const  get1SpatialAssessmentData = (dataGraph) =>{
        let query = `
          SELECT  ?ObservationURI ?TimePeriod ?Value ?MetricUri ?maxTimePeriod ?onBuildings
                   FROM NAMED  
              <${dataGraph}> 
              WHERE {

                    {GRAPH ?QualityGraph {?ObservationURI a daq:Observation} }.
                    {GRAPH ?QualityGraph {?ObservationURI daq:computedOn ?ComputedOn} }.
                    {GRAPH ?QualityGraph {?ObservationURI sdma:timePeriod ?TimePeriod} }.
                  {GRAPH ?QualityGraph {?ObservationURI daq:metric ?MetricUri} }.
                    #{GRAPH ?QualityGraph {?onBuildings <http://purl.org/eis/vocab/daq#computedOn>    <http://ontologies.adaptcentre.ie/dataset-hierarchy#BUILDING>} }.
                    {GRAPH ?QualityGraph {?ObservationURI daq:value ?Value} }.
                    {
                    SELECT  (max(?TimePeriod) AS ?maxTimePeriod)
                    WHERE {
                    {GRAPH ?QualityGraph {?x daq:computedOn ?ComputedOn} }.
                    {GRAPH ?QualityGraph {?a sdma:timePeriod ?TimePeriod} }.
                  }
                }.
                  

                  }
        `;

        return prefix + query;
    }

export default {get1SpatialAssessmentData};

//FILTER (?TimePeriod =  ?maxTimePeriod).