//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
//Query fro the 1Spatial dimension and related metrics

const  prefix = `
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> 
PREFIX daq: <http://purl.org/eis/vocab/daq#>
PREFIX sdma: <http://purl.org/linked-data/sdmx/2009/dimension#>
PREFIX cube: <http://purl.org/linked-data/cube#>
PREFIX prov: <http://www.w3.org/ns/prov#>
PREFIX sd: <http://www.w3.org/ns/sparql-service-description#>
PREFIX sdm: <http://standard.k-history.kr/resource/>
PREFIX pr: <http://purl.org/ontology/prv/core#>
PREFIX pro: <http://purl.org/hpi/patchr#>
        `;


export const  get1SpatialDimensions = (dataGraph) =>{
        let query = `
SELECT DISTINCT ?cat ?Metric ?dimInstance ?dim
        FROM NAMED  
        <${dataGraph}>
        WHERE {
            {GRAPH ?QualityGraph{?ObservationURI a daq:Observation}}.
            {GRAPH ?QualityGraph {?ObservationURI daq:metric ?Metric} }.
            {GRAPH ?QualityGraph {?cat a  <http://data.example.com/category/Oracle>} }.
            {GRAPH ?QualityGraph {?cat ?p  ?dimInstance} }.
            {GRAPH ?QualityGraph {?dimInstance a ?dim} }.
            {GRAPH ?QualityGraph {?dimInstance ?dimProp ?Metric} }.
            {GRAPH ?QualityGraph {?Metric a ?MetricURI} }.
            #{GRAPH ?QualityGraph {?ObservationURI rdfs?domain> ?Value} }.
            {GRAPH ?QualityGraph {?ObservationURI sdma:timePeriod ?TimePeriod} }.
            {
              SELECT  (max(?TimePeriod) AS ?maxTimePeriod)
              WHERE {
              {GRAPH ?QualityGraph {?x daq:computedOn ?ComputedOn} }.
              {GRAPH ?QualityGraph {?a sdma:timePeriod ?TimePeriod} }.
            }
        }.
        FILTER (?TimePeriod =  ?maxTimePeriod).
        }
        `;

        return prefix + query;
    }

export default {get1SpatialDimensions};