//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
//Query for all assessments and their time

const  prefix = `
          PREFIX daq: <http://purl.org/eis/vocab/daq#>
          PREFIX sdma: <http://purl.org/linked-data/sdmx/2009/dimension#>
        `;



export const  getAllAssessmentDates = (computedOn) =>{
        let query = `
          SELECT  DISTINCT ?QualityGraph ?ComputedOn ?TimePeriod
          WHERE {
            ?QualityGraph ?predicate daq:QualityGraph.
            {GRAPH ?QualityGraph {?x daq:computedOn ?ComputedOn} }.
            {GRAPH ?QualityGraph {?a sdma:timePeriod ?TimePeriod} }.
            FILTER(str(?ComputedOn) = "${computedOn}").
          }
          ORDER BY ASC(?TimePeriod)
        `;

        return prefix + query;
    }


export default {getAllAssessmentDates};
