//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
//Query to get all metric quality values

const  prefix = `
PREFIX daq: <http://purl.org/eis/vocab/daq#>
PREFIX sdma: <http://purl.org/linked-data/sdmx/2009/dimension#>
PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>
        `;



export const  getAssessmentQuality = (computedOn,timePeriod) =>{
        let query = `
        SELECT   ?Value ?Metric
        WHERE {
          ?QualityGraph ?predicate daq:QualityGraph.
          {GRAPH ?QualityGraph {?ObservationURI a daq:Observation} }.
          {GRAPH ?QualityGraph {?ObservationURI daq:computedOn ?ComputedOn} }.
          {GRAPH ?QualityGraph {?MetricURI daq:hasObservation ?ObservationURI} }.
          {GRAPH ?QualityGraph {?MetricURI a ?Metric} }.
          {GRAPH ?QualityGraph {?DimensionURI ?hasMetric ?MetricURI} }.
          {GRAPH ?QualityGraph {?DimensionURI a ?Dimension} }.
          {GRAPH ?QualityGraph {?CategoryURI ?hasDimension ?DimensionURI} }.
          {GRAPH ?QualityGraph {?CategoryURI a ?Category} }.
          {GRAPH ?QualityGraph {?ObservationURI sdma:timePeriod ?TimePeriod} }.
          {GRAPH ?QualityGraph {?ObservationURI daq:value ?Value} }.
          OPTIONAL{ {GRAPH ?ProblemGraph {?QualityProblem qpro:generatedBy ?Observation;
                                      qpro:problemStructure ?ProblemStructure} }.
                                      FILTER(?Observation IN (?ObservationURI)).
                                    }.
          FILTER(str(?ComputedOn) = "${computedOn}").
          FILTER (?Dimension != daq:Observation).
          FILTER (?TimePeriod =  "${timePeriod}"^^xsd:dateTime).
        }

        `;

        return prefix + query;
    }


export default {getAssessmentQuality};
