//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
//Query to get all recent assessment times
import React from 'react';

const  prefix = `
          PREFIX daq: <http://purl.org/eis/vocab/daq#>
          PREFIX sdma: <http://purl.org/linked-data/sdmx/2009/dimension#>
        `;



export const  getRecentAssessmentDates = (computedOn) =>{
        let query = `
          SELECT  (max(?TimePeriod) AS ?maxTimePeriod)
          WHERE {
            ?QualityGraph ?predicate daq:QualityGraph.
            {GRAPH ?QualityGraph {?x daq:computedOn ?ComputedOn} }.
            {GRAPH ?QualityGraph {?a sdma:timePeriod ?TimePeriod} }.
            FILTER(str(?ComputedOn) = "${computedOn}").
          }
        `;

        return prefix + query;
    }


export default {getRecentAssessmentDates};
