//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
//Query to get all recent assessment quality values and related data
const  prefix = `
PREFIX daq: <http://purl.org/eis/vocab/daq#>
PREFIX sdma: <http://purl.org/linked-data/sdmx/2009/dimension#>
PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>
        `;



export const  getRecentAssessmentQuality = (computedOn) =>{
        let query = `
        SELECT  ?ObservationURI ?TimePeriod ?Value ?Metric ?Dimension ?Category ?ProblemGraph ?QualityProblem ?ProblemStructure
        WHERE {
        	?QualityGraph ?predicate daq:QualityGraph.
          {GRAPH ?QualityGraph {?ObservationURI a daq:Observation} }.
          {GRAPH ?QualityGraph {?ObservationURI daq:computedOn ?ComputedOn} }.
          {GRAPH ?QualityGraph {?MetricURI daq:hasObservation ?ObservationURI} }.
          {GRAPH ?QualityGraph {?MetricURI a ?Metric} }.
          {GRAPH ?QualityGraph {?DimensionURI ?hasMetric ?MetricURI} }.
          {GRAPH ?QualityGraph {?DimensionURI a ?Dimension} }.
          {GRAPH ?QualityGraph {?CategoryURI ?hasDimension ?DimensionURI} }.
          {GRAPH ?QualityGraph {?CategoryURI a ?Category} }.
          {GRAPH ?QualityGraph {?ObservationURI sdma:timePeriod ?TimePeriod} }.
          {GRAPH ?QualityGraph {?ObservationURI daq:value ?Value} }.
          {
          SELECT  (max(?TimePeriod) AS ?maxTimePeriod)
        	WHERE {
          ?QualityGraph ?predicate daq:QualityGraph.
          {GRAPH ?QualityGraph {?x daq:computedOn ?ComputedOn} }.
          {GRAPH ?QualityGraph {?a sdma:timePeriod ?TimePeriod} }.
          FILTER(str(?ComputedOn) = "${computedOn}").
        }
      }.
      OPTIONAL{ {GRAPH ?ProblemGraph {?QualityProblem qpro:generatedBy ?Observation;
                                        qpro:problemStructure ?ProblemStructure} }.
                                        FILTER(?Observation IN (?ObservationURI)).
                                      }.
          FILTER (?Dimension != daq:Observation).
          FILTER (?TimePeriod =  ?maxTimePeriod).
        }

        `;

        return prefix + query;
    }


export default {getRecentAssessmentQuality};
