//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.

const  prefix = `
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>
PREFIX rdf:     <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX dqm-prob: <http://www.diachron-fp7.eu/dqm-prob#>
PREFIX dqm:	<http://purl.org/eis/vocab/dqm#>
        `;



export const  getErrorReportForModelDefault = (graph,observationURI, exceptions, hasExceptions) =>{
        let query = `
        SELECT  (COALESCE(IF(BOUND(?HasProblematicThing), ?ProblematicThingResourceRef,?Empty)) AS ?ProblematicThingResource) ?Exception (COALESCE(?HasProblematicThing, ?ProblematicThingResourceRef) as ?ProblematicThing)
		FROM NAMED <${graph}>
WHERE {
{GRAPH ?QualityGraph {?QualityProblem qpro:generatedBy ?Observation;
                                     qpro:isDescribedBy ?IsDescribedBy;
                                     qpro:problemStructure qpro:ModelContainer;
                                     qpro:problematicThing ?ProblematicThingResourceRef} }.


{
   {GRAPH ?QualityGraph {?ProblematicThingResourceRef ?Description ?Exception }}.
   FILTER(?Exception IN (${exceptions})).
}.


OPTIONAL    {
 {GRAPH ?QualityGraph {?ProblematicThingResourceRef ?hasException ?HasProblematicThing }}.
  FILTER(?hasException IN (${hasExceptions})).
}.

 FILTER(str(?Observation) = "${observationURI}").
}        `;

        return prefix + query;
    }


export default {getErrorReportForModelDefault};
