//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.

const  prefix = `
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>
PREFIX rdf:     <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX dqm-prob: <http://www.diachron-fp7.eu/dqm-prob#>
PREFIX dqm:	<http://purl.org/eis/vocab/dqm#>
        `;



export const  getErrorReportForModelProblematicTriple = (graph,observationURI) =>{
        let query = `
        SELECT  ?ProblematicThing ?ProblematicThingResource ?Exception
		FROM NAMED <${graph}>
WHERE {
  {GRAPH ?QualityGraph {?QualityProblem qpro:generatedBy ?Observation;
                                       qpro:isDescribedBy ?IsDescribedBy;
                                       qpro:problemStructure qpro:ModelContainer;
                                       qpro:problematicThing ?ProblematicThingRef} }.
  {GRAPH ?QualityGraph {?ProblematicThingRef ?Description ?Exception;
                                          dqm-prob:problematicTriple ?ProblematicTriple}}.
  {GRAPH ?QualityGraph {?ProblematicTriple rdf:subject ?ProblematicThingResource;
                                           rdf:predicate ?ProblematicThing}}.
 FILTER(str(?Observation) = "${observationURI}").
 FILTER(?Description = rdf:type).
}
        `;

        return prefix + query;
    }


export default {getErrorReportForModelProblematicTriple};
