//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.

const  prefix = `
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>
PREFIX rdf:     <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX dqm-prob: <http://www.diachron-fp7.eu/dqm-prob#>
PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
PREFIX dqm: <http://purl.org/eis/vocab/dqm#>
        `;



export const  getErrorReportForQuad = (graph,observationURI) =>{
        let query = `
SELECT (COALESCE(IF(?predicate=qpro:exceptionDescription, ?Subject, ?Object)) AS ?ProblematicThing)  (?Subject AS ?ProblematicThingResource) ?Exception
		FROM NAMED <${graph}>
WHERE {
	{GRAPH ?QualityGraph {?QualityProblem qpro:generatedBy ?Observation;
    										qpro:isDescribedBy ?IsDescribedBy;
              								qpro:problemStructure qpro:QuadContainer;
                      						qpro:problematicThing ?ProblematicThings}}.
  {GRAPH ?QualityGraph {?ProblematicThings ?Sequence ?ProblematicResource}}.
  {GRAPH ?QualityGraph {?ProblematicResource rdf:object ?Object;
                                             rdf:predicate ?predicate;
                                             rdf:subject ?Subject}}.
	 FILTER(str(?Observation) = "${observationURI}").
   BIND(IF(?IsDescribedBy=dqm:CompatibleDatatype, xsd:dt-unknown-dt, ?Object) AS ?Exception).
}
`;

        return prefix + query;
    }


export default {getErrorReportForQuad};
