//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.

const  prefix = `
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>
PREFIX rdf:     <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX dqm-prob: <http://www.diachron-fp7.eu/dqm-prob#>
PREFIX dqm: <http://purl.org/eis/vocab/dqm#>
        `;



export const  getErrorReportForResource = (graph,observationURI) =>{
        let query = `
SELECT  ?ProblematicThing (?ProblematicThing AS?ProblematicThingResource) ?Exception
		FROM NAMED <${graph}>
WHERE {
	{GRAPH ?QualityGraph {?QualityProblem qpro:generatedBy ?Observation;
                                       	qpro:isDescribedBy ?IsDescribedBy;
                                        qpro:problemStructure qpro:ResourceContainer;
                                        qpro:problematicThing ?Problems} }.
	{GRAPH ?QualityGraph {?Problems ?Sequence ?ProblematicThing } }.
	 FILTER(str(?Observation) = "${observationURI}").
  	 FILTER (?Sequence != rdf:type).
     BIND(IF(?IsDescribedBy=dqm:HumanReadableLabellingMetric, dqm-prob:NoHumanReadableLabel, "Unknown") AS ?Exception).
}        `;

        return prefix + query;
    }


export default {getErrorReportForResource};
