//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.

const  prefix = `
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>
PREFIX rdf:     <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX dqm-prob: <http://www.diachron-fp7.eu/dqm-prob#>
PREFIX dqm: <http://purl.org/eis/vocab/dqm#>
        `;



export const  listOfAllMetricsFailedForResource = (graph,resource) =>{
        let query = `
        SELECT  ?IsDescribedBy ?Exception
        FROM NAMED <${graph}>
        WHERE
        {
        		{{GRAPH ?QualityGraph {?QualityProblemRef qpro:problematicThing ?Problems;
        												qpro:problemStructure ?ProblemStructure;
                                                       	qpro:isDescribedBy ?IsDescribedBy}}.
        						{GRAPH ?QualityGraph {?Problems ?Sequence ?ProblematicThing } }.
        		}
            UNION
        		{{GRAPH ?QualityGraph {?QualityProblemRef qpro:problematicThing ?ProblematicThing;
        												qpro:problemStructure ?ProblemStructure;
                                                       	qpro:isDescribedBy ?IsDescribedBy}}.
        		{GRAPH ?QualityGraph {?ProblematicThing qpro:exceptionDescription ?Exception}}.
        		}
            UNION
        		{{{GRAPH ?QualityGraph {?QualityProblemRef qpro:problematicThing ?ProblematicThingRef;
        												qpro:problemStructure ?ProblemStructure;
        												qpro:isDescribedBy ?IsDescribedBy} }.
        		{GRAPH ?QualityGraph {?ProblematicThingRef ?ProblemDescription ?ProblemDetails;
        												a ?Exception}}.
        		{GRAPH ?QualityGraph {?ProblemDetails rdf:subject ?ProblematicThing}}.
        			FILTER(?ProblemDescription = dqm-prob:problematicTriple).}
        		}
        	UNION
        		{{{GRAPH ?QualityGraph {?QualityProblemRef qpro:problematicThing ?ProblematicThingRef;
        												qpro:problemStructure ?ProblemStructure;
                    									qpro:isDescribedBy ?IsDescribedBy} }.
        		{GRAPH ?QualityGraph {?ProblematicThingRef ?Sequence ?ProblematicResource}}.
        		{GRAPH ?QualityGraph {?ProblematicResource rdf:subject ?ProblematicThing;
        													rdf:predicate ?Predicate;
        													rdf:object ?Exception}}.
        			FILTER(?Sequence != dqm-prob:problematicTriple).}
                 }
            FILTER(str(?ProblematicThing) =  "${resource}").
        }
        `;

        return prefix + query;
    }


export default {listOfAllMetricsFailedForResource};
