//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
import axios from 'axios';
import properties from '../../config/dashboardProperties';

const host = properties.tripleStore.host;
const port = properties.tripleStore.port;
const dataStore = properties.tripleStore.datastore;
/*-------------config-------------*/
const config ={
    baseURL: 'http://'+host+'/$/stats/',
    timeout: 10000,
    headers: {'Accept': 'application/json','Content-Type':'application/x-www-form-urlencoded'},
    withCredentials: true,
    auth: {username: properties.tripleStore.userName, password: properties.tripleStore.password}
  };
/*-----------------------------------*/


export const statusUpdate = (query) => axios.get(dataStore, config)
                .then((response) => {

                    return response;
                })
                .catch((err) => {
                  if (!err.response) {
                              // network error
                            console.log('Error: Network Error. Unable to connect to '+ host+":"+port);
                  } else {
                            console.log(err.response.data.message);
                  }
                    //return err;
                })

export default {statusUpdate};
