//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
import axios from 'axios';
import properties from '../../config/dashboardProperties';

/*-------------config-------------*/
const config ={
    timeout: 10000,
    headers: {'Accept': 'application/json','Content-Type':'application/x-www-form-urlencoded'},
    withCredentials: true,
    auth: {username: properties.tripleStore.userName, password: properties.tripleStore.password}
  };

/*-----------------------------------*/


const host = properties.tripleStore.host;
const port = properties.tripleStore.port;
const dataStore = properties.tripleStore.datastore;
let url = "http://"+host+"/"+dataStore+"/data";


export const uploadToTripleStore = (fileToUpload, fileName) => {
  const formData = new FormData();
  formData.append('file', fileToUpload);

return  axios.post(url, formData, {...config, params : {"graph": fileName}})
  .then((response) => {
      return response;})
  .catch((err) => {
    if (!err.response) {
                // network error
              console.log('Error: Network Error. Unable to connect to '+ host+":"+port);
    } else {
              console.log(err.response.data.message);
    }
      return err;
  });


}


export default {uploadToTripleStore};
