//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
const initialState = {
  modalConfigOpen: false,
  modalOptionsOpen : false,
  datasetName: "",
  isSparqlEndPoint: false,
  sparqlEndPointURL: "",
  datasetPLD: "",
  fileToUpload: null,
  historyFileToUpload: null,
  datasetNameValid: true,
  datasetNameDisabled : false,
  datasetPLDValid: true,
  datasetPLDDisabled : false,
  datasetPLDMandatoryValid: true,
  datasetPLDPrefixValid: true,
  sparqlEndPointURLValid: true,
  fileUploadValid: true,
  fileUploadMandatory: true,
  fileFormatValid: true,
  fileUploadProgress: 0,
  showFileUploadProgress: false,
  fileUploadCompleted : false,
  historyFileUploadCompleted : false,
  fileUploadSuccessfull: false,
  historyFileUploadSuccessfull: false,
  fileUploadedName : "",
  fileUploadedPath : "",
  dimensionsToAssess : [],
  assessmentDetails : [],
  prevAssessmentDetails : [],
  datasetID : "",
  displayUseExistingFileCheckBox : false,
  useExistingFile : false,
  qualityMetrics : []

}

const connectDatasetReducer = (state = initialState, action) => {

  switch (action.type){
    case "OPEN_CONFIG_MODEL":
    return({
      ...state,
      modalConfigOpen:true,
      modalOptionsOpen : false
    });
    case "REOPEN_CONFIG_MODEL":
    let hasExistingFile=false;
    if(action.payLoad.fileName!=="")
    {
      hasExistingFile=true;
    }
    return({
      ...state,
      datasetID : action.payLoad.datasetID,
      datasetName:action.payLoad.datasetName,
      datasetPLD:action.payLoad.datasetPLD,
      isSparqlEndPoint:action.payLoad.isSparqlEndPoint,
      sparqlEndPointURL:action.payLoad.sparqlEndPoint,
      prevAssessmentDetails : [...action.payLoad.assessmentMetrics],
      datasetNameDisabled : true,
      datasetPLDDisabled : true,
      fileUploadedPath : (action.payLoad.fileName).substring(0, (action.payLoad.fileName).lastIndexOf("/") + 1),
      fileUploadedName : (action.payLoad.fileName).substring((action.payLoad.fileName).lastIndexOf("/") + 1, (action.payLoad.fileName).length),
      displayUseExistingFileCheckBox : hasExistingFile,
      useExistingFile : hasExistingFile,
      modalConfigOpen:true,
      modalOptionsOpen : false
    });
    case "OPEN_OPTION_MODEL":
    return({
      ...action.payLoad,
      modalConfigOpen:false,
      modalOptionsOpen : true
    });
    case "BACK_CONFIG_MODEL":
    return({
      ...action.payLoad,
      modalConfigOpen:true,
      modalOptionsOpen : false
    });
    case "CLOSE_CONFIG_MODEL":
    return({
      ...initialState
    });
    case "CLOSE_OPTION_MODEL":
    return({
      ...initialState
    });
    default:
    return (
      {...state,
      modalConfigOpen:false,
      modalOptionsOpen : false
    });
    }
};

export default connectDatasetReducer;
