//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
const initialState = {
  datasetDetailsCache : [],
  pipelineCache : [],
  loggedIn: false
}

const datasetDetailsCacheReducer = (state = initialState, action) => {
  let fromSessionStore = JSON.parse(sessionStorage.getItem("DATASETCACHE"));
  let pipelineStore = JSON.parse(sessionStorage.getItem("PIPELINECACHE"));

  switch (action.type){
    case "CREATE_DATASET_DETAILS_CACHE":
    //console.log("CREATE_DATASET_DETAILS_CACHE");
    //console.log(action.payLoad);
    sessionStorage.setItem("DATASETCACHE",JSON.stringify(action.payLoad) );
    return({
      datasetDetailsCache : [...action.payLoad]
    });
    case "ADD_DATASET_DETAILS_CACHE":
    //console.log("ADD_DATASET_DETAILS_CACHE");
    //console.log(action.payLoad);
    //console.log(fromSessionStore);
    fromSessionStore.push(action.payLoad);
    //console.log(fromSessionStore);
    sessionStorage.setItem("DATASETCACHE",JSON.stringify(fromSessionStore) );
    return({
      datasetDetailsCache : [...fromSessionStore]
    });
    case "UPDATE_DATASET_DETAILS_CACHE":
    //console.log("UPDATE_DATASET_DETAILS_CACHE");
    //console.log(action.payLoad);
    //console.log(action.payLoad.datasetID);
    //console.log(fromSessionStore);
    let storeToUpdate = [...fromSessionStore];
    let indexOfDatasetToUpdate = storeToUpdate.findIndex((datasetDetails)=>{return datasetDetails.datasetID===action.payLoad.datasetID});
    //console.log(indexOfDatasetToUpdate);
    //console.log(storeToUpdate[indexOfDatasetToUpdate]);
    let updateData = {
      ...storeToUpdate[indexOfDatasetToUpdate],
      ...action.payLoad
    }
    //console.log(updateData);
    storeToUpdate[indexOfDatasetToUpdate]=updateData;
    //console.log(storeToUpdate);
    sessionStorage.setItem("DATASETCACHE",JSON.stringify(storeToUpdate));
    return({
      datasetDetailsCache : [...storeToUpdate]
    });

    case "UPDATE_METRIC_ERROR_REPORT_CACHE":
    //console.log("UPDATE_METRIC_ERROR_REPORT_CACHE");
    //console.log(action.payLoad);
    //console.log(action.payLoad.datasetID);
    //console.log(fromSessionStore);
    let storeToUpdateErrorReport = [...fromSessionStore];
    let indexOfDatasetToUpdateErrorReport = storeToUpdateErrorReport.findIndex((datasetDetails)=>{ return datasetDetails.datasetID===action.payLoad.datasetID});
    //console.log(indexOfDatasetToUpdateErrorReport);
    storeToUpdateErrorReport[indexOfDatasetToUpdateErrorReport].lastAssessmentMetrics[action.payLoad.metricIndex]= {...storeToUpdateErrorReport[indexOfDatasetToUpdateErrorReport].lastAssessmentMetrics[action.payLoad.metricIndex], errorReport:action.payLoad.errorReport};
    //console.log(storeToUpdateErrorReport[indexOfDatasetToUpdateErrorReport]);
    sessionStorage.setItem("DATASETCACHE",JSON.stringify(storeToUpdateErrorReport));
    return({
      datasetDetailsCache : [...storeToUpdateErrorReport]
    });

    case "REMOVE_DATASET_DETAILS_CACHE":
    //console.log("REMOVE_DATASET_DETAILS_CACHE");
    //console.log(action.payLoad);
    let afterRemovedDataset = fromSessionStore.filter((datasetDetails)=>{return datasetDetails.datasetID!==action.payLoad.datasetID});
    //console.log(afterRemovedDataset);
    sessionStorage.setItem("DATASETCACHE",JSON.stringify(afterRemovedDataset));
    return({
      datasetDetailsCache : [...afterRemovedDataset]
    });

    case "CREATE_PIPELINE_CACHE":
    //console.log("CREATE_DATASET_DETAILS_CACHE");
    console.log(action.payLoad);
    sessionStorage.setItem("PIPELINECACHE",JSON.stringify(action.payLoad) );
    return({
      pipelineCache : [...action.payLoad]
    });
    case "ADD_PIPELINE_CACHE":
    //console.log("ADD_DATASET_DETAILS_CACHE");
    console.log(unescape(encodeURIComponent(JSON.stringify(sessionStorage))).length)
    console.log(unescape(encodeURIComponent(JSON.stringify(action.payLoad))).length)
    console.log(action.payLoad);
    //console.log(fromSessionStore);
    pipelineStore.push(action.payLoad);
    sessionStorage.setItem("PIPELINECACHE",JSON.stringify(pipelineStore) );
    return({
      pipelineCache : [...pipelineStore]
    });

    case "SET_IS_LOGGED_IN":
    console.log(action.payLoad);
    return({
      loggedIn: action.payload
    });

    case "UPDATE_HISTORIC_ASSESSMENT_DETAILS_CACHE":
    //console.log("UPDATE_HISTORIC_ASSESSMENT_DETAILS_CACHE");
    //console.log(action.payLoad);
    let prevStore = [...fromSessionStore];
    let index = prevStore.findIndex((datasetDetails)=>{return datasetDetails.datasetID===action.payLoad.datasetID});
    let modifyDataset=null;
    //console.log(prevStore[index]);
    //console.log(prevStore[index].historicAssessmentData);
    if(typeof prevStore[index].historicAssessmentData==="undefined")
    {
        modifyDataset={
          ...prevStore[index],
          historicAssessmentData : [action.payLoad.historicAssessmentData]
        };
    }
    else {
      modifyDataset={
        ...prevStore[index],
        historicAssessmentData : [...prevStore[index].historicAssessmentData,action.payLoad.historicAssessmentData]
      };
    }
    //console.log(modifyDataset);
    prevStore[index]=modifyDataset;
    //console.log(prevStore);
    sessionStorage.setItem("DATASETCACHE",JSON.stringify(prevStore) );
    return({
      datasetDetailsCache : [...prevStore]
    });

    default:
    //console.log("DEFAULT");
    if(fromSessionStore!==null)
    {
      //console.log("NOT EMPTY");
      //console.log(fromSessionStore);
      return (
        {
          datasetDetailsCache:[...fromSessionStore],
          pipelineCache:[...pipelineStore]
      });
    }

    return (
      {
        ...state
    });
    }
};

export default datasetDetailsCacheReducer;
