//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
import React from 'react';
import { Modal, ModalBody,ModalHeader,ModalFooter, Button, ListGroup, ListGroupItem, ListGroupItemHeading, ListGroupItemText} from 'reactstrap';

const ProblemsModel = (props) => {
  let problems=null;
  problems =(
    props.assessmentProblems.map((problem,index)=>{
      let title="";
      title=(Object.keys(problem))[0].split("#")[1];
      let details = "";
      let additionalDetails = "";
      //console.log(title);
      if (title===undefined) {
        title=(Object.keys(problem))[0];
        details = problem[Object.keys(problem)];
      }
      else {
        title = "Please select any one Metric for : " + (Object.keys(problem))[0].split("#")[1];
        details=problem[Object.keys(problem)].join(', ');
      }
      if(title==="WrapperServiceNotAvailable")
      {
        additionalDetails="Please ensure that Wrapper API Service endpoint is defined correctly and running.";
      }
      if(title==="datasetPLDAlreadyExists")
      {
        additionalDetails="Please enter a different Dataset PLD in Configuration Screen.";
      }
      return (<ListGroupItem key={index}><ListGroupItemHeading>{title}</ListGroupItemHeading><ListGroupItemText>{details}</ListGroupItemText><ListGroupItemText>{additionalDetails}</ListGroupItemText></ListGroupItem>)
    })
  );

  //console.log(props.assessmentProblems);
  return (
    <Modal isOpen={true} className="modal-dialog-centered">
    <ModalHeader style={{ margin: 'auto' }}>List of Issues</ModalHeader>
      <ModalBody>
        <div className="animated fadeIn pt-1 text-center">Please correct the following issue(s):</div>
        <ListGroup>
        {problems}
        </ListGroup>
      </ModalBody>
      <ModalFooter>
          <Button color="secondary" onClick={props.clickHandler}>Ok</Button>
      </ModalFooter>
    </Modal>
  );

}


export default ProblemsModel;
