//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
import React, { Component } from 'react';
import {
  ListGroupItem, FormGroup, Input, Label, UncontrolledTooltip, Card, CardBody, CardText
} from 'reactstrap';
import { connect } from 'react-redux';

class MetricFilter extends Component {

  componentDidMount() {
    //console.log(this.props);
  }

  render() {
    let metrics = "";
    metrics = (this.props.metrics.map((metric, index) => {
      var toolTip = this.props.datasetDetailsCache[0].assessmentMetrics.find((metricDetails) => {
        if (metricDetails.metric.split("#")[1] === metric) {
          return metricDetails.comment;
        }
      });
      //console.log(toolTip);
      return <ListGroupItem key={index} className="border-0">
        <FormGroup check inline>
          <Input className="form-check-input" type="checkbox" id={metric} name={metric} value={metric} onChange={this.props.updateFilter} defaultChecked={false} />
          <Label className="form-check-label" check htmlFor={metric}>{metric} <i className="fa fa-info-circle" id={metric + "_toolTipIcon"}></i><UncontrolledTooltip placement="right" target={metric + "_toolTipIcon"}>{toolTip.comment}</UncontrolledTooltip></Label>
        </FormGroup>
      </ListGroupItem>
    }));
    //console.log(metrics);
    if (metrics.length === 0) {
      //console.log("EMPTY");
      metrics = (<Card className="w-100 text-center" style={{ border: "none" }} >
        <CardBody>
          <CardText>No Metrics to list. Please select a different view.</CardText>
        </CardBody>
      </Card>);
    }
    return (
      <React.Fragment>
        {metrics}
      </React.Fragment>
    );
  }
}


const mapStateToProps = (state, ownProps) => {
  let datasetID = Number(ownProps.datasetID);
  let datasetDetails = state.datasetDetailsCache.filter((dataset) => { if (dataset.datasetID === datasetID) { return dataset; } return null; });
  return (
    {
      datasetDetailsCache: datasetDetails
    }
  );
}

export default connect(mapStateToProps)(MetricFilter);
