//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
import React, { Component } from 'react';
import {
  ListGroupItem
} from 'reactstrap';

class ResourceList extends Component {
  constructor(props) {
    //console.log("constructor");
    super(props);
    this.state = {
    }
    //console.log(this.props);
  }

  componentDidMount() {
    //console.log("componentDidMount");
  }

  render() {
    //console.log("Render");
    //console.log(this.state);
    let returnList = null;
    returnList = this.props.resourceList.map((resource, index) => {
      let resourceKey = Object.keys(resource);
      return <ListGroupItem key={index} className="list-group-item list-group-item-action flex-column align-items-start" >
        <h5 className="mb-1">Resource:</h5>
        <div className="d-flex w-100 justify-content-between">
          <h6 className="mb-1">{resourceKey[0]}</h6>
        </div>
        <p className="mb-1"></p>
        <p style={{ fontSize: "14px" }}>{resource[resourceKey].exception.length} Exception(s) Related to this Resource : {resource[resourceKey].exception.join(', ')}</p>
        <div className="d-flex w-100 justify-content-between">
          <p className="mb-1">
            {resource[resourceKey].resourceReplica.length > 0 ? <small>Also has '{resource[resourceKey].resourceReplica.length}' Resource Replica </small> : null}
            {resource[resourceKey].disjointClass.length > 0 ? <small>and '{resource[resourceKey].disjointClass.length}' Disjoint Classes.</small> : null}
          </p>
          <button style={{ color: "#069", fontSize: "16px", textDecoration: "underline", background:"none",padding:"0", border:"none", cursor:"ponter" }} onClick={() => this.props.showDetails(index)}>Click here for more details..</button>
        </div>
      </ListGroupItem>
    });
    return (
      <React.Fragment>
        {returnList}
      </React.Fragment>
    );
  }
}

export default ResourceList;
