//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
import React from 'react';
import { Modal, ModalBody,ModalHeader,ModalFooter, Button, ListGroup, ListGroupItem, ListGroupItemHeading, ListGroupItemText} from 'reactstrap';

const ProblemsModel = (props) => {
  let problems=null;
  problems =(
    props.triggerProblems.map((problem,index)=>{
      let key=Object.keys(problem)[0];
      let additionalDetails="";
      if(key==="DataSetGraphNotFound")
      {
        additionalDetails="Please add the dataset graph manually to triple store.";
      }
      if(key==="MultipleGraphsFound")
      {
        additionalDetails="Please remove duplicate graphs with same name manually from triple store.";
      }

      return (<ListGroupItem key={index}><ListGroupItemHeading>{key}</ListGroupItemHeading><ListGroupItemText>{problem[key]}</ListGroupItemText><ListGroupItemText>{additionalDetails}</ListGroupItemText></ListGroupItem>)
    })
  );

  //console.log(props.assessmentProblems);
  return (
    <Modal isOpen={true} className="modal-dialog-centered">
    <ModalHeader style={{ margin: 'auto' }}>Issue in Knowledge Base Generation</ModalHeader>
      <ModalBody>
        <div className="animated fadeIn pt-1 text-center">Please correct the following issue(s):</div>
        <ListGroup>
        {problems}
        </ListGroup>
      </ModalBody>
      <ModalFooter>
          <Button color="secondary" onClick={props.clickHandler}>Ok</Button>
      </ModalFooter>
    </Modal>
  );

}


export default ProblemsModel;
