//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.
import React, { Component, useState } from "react";
import { Button, Form } from "react-bootstrap";
import { Link, Redirect } from "react-router-dom";
import { connect } from 'react-redux';

class Login extends Component {
  constructor(props) {
    super(props);
    this.state = {
      password: '',
      validate: false,
      redirect: false
    };
  }

  handlePasswordChange = (event) => {
    if(event.length > 0){
        this.setState({password: event, validate: true})
    }else{
        this.setState({password: event, validate: false})
    }
  }
  setRedirect = () => {
    if (this.state.password === 'e') {
        this.setState({
          redirect: true
        })
    }
  }
  renderRedirect = () => {
    if (this.state.redirect) {
      return <Redirect to="/pipeline" />;
    }
  }


  render (){
      return (
        <div className="Login">
          <Form >
            <Form.Group controlId="password" bsSize="large">
              <Form.Label>Password</Form.Label>
              <Form.Control
                value={this.state.password}
                onChange={e => this.handlePasswordChange(e.target.value)}
                type="password"
              />
            </Form.Group>
            {this.renderRedirect()}
            <Button block onClick={this.setRedirect} bsSize="large" disabled={!this.state.validate} type="submit">
              Login
            </Button>
          </Form>
        </div>
      );
  }
}


export default Login;

