//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.

const  prefix = `
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>
PREFIX rdf:     <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX dqm-prob: <http://www.diachron-fp7.eu/dqm-prob#>
        `;



export const  HumanReadableLabellingMetric = (qualityGraph,dataGraph,observationURI,datasetSource) =>{
        let query = `
SELECT (COALESCE(?Default, "Subject") AS ?ProblematicThing) ?Subject ?Predicate ?Object ?FailedMertic (COALESCE(?Default, dqm-prob:NoHumanReadableLabel) AS ?Exception)
FROM NAMED <${qualityGraph}>
WHERE 
{
{GRAPH <${qualityGraph}>
	{?QualityProblem qpro:generatedBy ?Observation;
		a qpro:QualityProblem;
		qpro:isDescribedBy ?FailedMertic;
		qpro:problemStructure qpro:ResourceContainer;
		qpro:problematicThing ?SequenceRef}.
}
{GRAPH <${qualityGraph}>
	{?SequenceRef ?Sequence ?Subject}.}
	FILTER(str(?Observation) = "${observationURI}").
  	FILTER (?Sequence != rdf:type).
}
		`;

        return prefix + query;
    }


export default {HumanReadableLabellingMetric};
