//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.

const  prefix = `
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>
PREFIX rdf:     <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX dqm-prob: <http://www.diachron-fp7.eu/dqm-prob#>
        `;



export const  UsageOfIncorrectDomainOrRangeDatatypesMetric = (qualityGraph,dataGraph,observationURI,datasetSource) =>{
        let query = `
SELECT  ?ProblematicThing ?Subject ?Predicate ?Object ?FailedMertic ?Exception 
FROM NAMED <${qualityGraph}>
WHERE
{
{GRAPH <${qualityGraph}>
	{?QualityProblem qpro:generatedBy ?Observation;
		a qpro:QualityProblem;
		qpro:isDescribedBy ?FailedMertic;
		qpro:problemStructure qpro:ModelContainer;
		qpro:problematicThing ?ProblematicThingRef}.
} 
{{GRAPH <${qualityGraph}>	
	{?ProblematicThingRef a ?Exception;
		dqm-prob:problematicTriple ?ProblematicTriple}.
    	FILTER(?Exception IN (dqm-prob:IncorrectRange,dqm-prob:IncorrectDomain,dqm-prob:UnknownType)).}
}
{
 {GRAPH <${qualityGraph}>
     {?ProblematicTriple rdf:subject ?Subject;
		rdf:object ?Object;
        rdf:predicate ?Predicate}.}   
 }   
    
  BIND(COALESCE(
    IF(?Exception = dqm-prob:IncorrectRange, "Predicate",IF(?Exception = dqm-prob:IncorrectDomain, "Predicate",IF(?Exception = dqm-prob:UnknownType, "Object","")))
  ) AS ?ProblematicThing).  
FILTER(str(?Observation) = "${observationURI}").
}
		`;

        return prefix + query;
    }


export default {UsageOfIncorrectDomainOrRangeDatatypesMetric};
