//© 2019 Dublin City University, Trinity College Dublin. All rights reserved. This material may not be reproduced, displayed, modified or distributed without the express prior written permission of the copyright holder.

const  prefix = `
PREFIX qpro: <http://purl.org/eis/vocab/qpro#>
PREFIX rdf:     <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX dqm-prob: <http://www.diachron-fp7.eu/dqm-prob#>
PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
        `;



export const  CompatibleDatatype = (qualityGraph,dataGraph,observationURI,datasetSource) =>{
        let query = `
SELECT ?Subject ?Predicate ?Object ?FailedMertic (COALESCE(?Default, xsd:dt-unknown-dt) AS ?Exception)
FROM NAMED <${qualityGraph}>
WHERE 
{
{GRAPH <${qualityGraph}>
	{?QualityProblem qpro:generatedBy ?Observation;
		a qpro:QualityProblem;
		qpro:isDescribedBy ?FailedMertic;
		qpro:problemStructure qpro:QuadContainer;
		qpro:problematicThing ?SequenceRef}.
}
{GRAPH <${qualityGraph}> 
	{?SequenceRef ?Sequence ?Statement}.}
{GRAPH <${qualityGraph}> 
    {?Statement rdf:object ?Object;
		rdf:predicate ?Predicate;
		rdf:subject ?Subject}.}
	 FILTER(str(?Observation) = "${observationURI}").
  
}
		`;

        return prefix + query;
    }


export default {CompatibleDatatype};
