# Dashboard Installation
## Luzzu Dashboard
### Prerequisites
	1.  NodeJS: [https://nodejs.org/en/download/](https://nodejs.org/en/download/)
    
	2.  NPM: [https://www.npmjs.com/get-npm](https://www.npmjs.com/get-npm)

### Steps
1.  Install Pre-requisites
    
2.  Using Command Prompt (Windows) or Terminal (Linux), navigate to “Luzzu Dashboard” directory.
    
3.  Use command “npm install” to download and install dependencies
    
4.  Then use command “npm start” to start nodejs server in port 3000

### Config file
1.  Navigate to src/config directory
    
2.  Open dashboardProperties.js file
    
3.  Update the host and port details of dependent systems like Luzzu Framework, TripleStore and Service Wrapper

## Luzzu Dashboard Wrapper API
### Steps
1.  Install Pre-requisites
    
2.  Using Command Prompt (Windows) or Terminal (Linux), navigate to “LuzzuDashboard-Wrapper-API” directory.
    
3.  Use command “npm install” to download and install dependencies
    
4.  Then use command “npm start” to start nodejs server in port 5000

## Apache Jena Fuseki Server (TripleStore)
### Prerequisites
	1.  Apache Jena Fuseki 3.11.0: [https://jena.apache.org/download/index.cgi](https://jena.apache.org/download/index.cgi)
### Steps
1.  Install Pre-requisites
    
2.  Create an empty folder named OSiDatastore
    
3.  Using Command Prompt (Windows) or Terminal (Linux), navigate to “apache-jena-fuseki-3.11.0” directory.
    
4.  Use command below command to initialize or run the triple store.
    

sudo java -jar fuseki-server.jar --loc='loc to OSiDatastore' /fusekiserver

  

DIR can be directory location in the system.

NAME is the name of the datastore name.

  

Please refer to [https://jena.apache.org/documentation/fuseki2/fuseki-run.html](https://jena.apache.org/documentation/fuseki2/fuseki-run.html) for running Fuseki as Standalone Server